<div align="center">
    <h1>📦 useCustomHooks 📦</h1>
    <p>npm package containing a set of custom hooks for your next React project.</p>
	<br/>
	<div align="center">
  <a href= "https://www.npmjs.com/package/use-custom-hooks/v/latest">
		<img alt="npm" src="https://img.shields.io/npm/v/use-custom-hooks?style=for-the-badge">
	</a>
	<a href= "https://www.npmjs.com/package/use-custom-hooks/">
		<img alt="npm bundle size" src="https://img.shields.io/bundlephobia/minzip/use-custom-hooks?style=for-the-badge">
	</a>
	<a href= "https://www.npmjs.com/package/use-custom-hooks/">
		<img alt="npm Downloads/Week" src="https://img.shields.io/npm/dw/use-custom-hooks?style=for-the-badge">
	</a>
	<a href="https://github.com/aromalanil/useCustomHooks/issues">
		<img alt="GitHub issues" src="https://img.shields.io/github/issues/aromalanil/useCustomHooks?style=for-the-badge">
	</a>
  <a href="https://github.com/aromalanil/useCustomHooks/commits/master">
    <img alt="GitHub last commit" src="https://img.shields.io/github/last-commit/aromalanil/useCustomHooks?style=for-the-badge">
  </a>
	<a href="https://github.com/aromalanil/useCustomHooks/blob/master/LICENSE">
		<img alt="GitHub License" src="https://img.shields.io/github/license/aromalanil/useCustomHooks?style=for-the-badge">
	</a>
  </br>

<!-- ALL-CONTRIBUTORS-BADGE:START - Do not remove or modify this section -->
<a href="https://github.com/aromalanil/useCustomHooks/graphs/contributors"><img src="https://img.shields.io/badge/all_contributors-5-orange.svg?style=for-the-badge" /></a>
<!-- ALL-CONTRIBUTORS-BADGE:END --> 

  </div>
</div>
<br/>

## 🧰 Installation

### Using npm or yarn 📦

```bash
# Using npm
npm i use-custom-hooks

# Using yarn
yarn add use-custom-hooks
```
## 📘 Available Hooks

- [useForm](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-useForm)
- [useStack](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usestack)
- [useQueue](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usequeue)
- [useToggle](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usetoggle)
- [usePrevious](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-useprevious)
- [useDebounce](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usedebounce)
- [useDarkMode](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usedarkmode)
- [useMediaQuery](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usemediaquery)
- [useGeoLocation](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usegeolocation)
- [useLocalStorage](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-uselocalstorage)
- [useMousePosition](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-usemouseposition)
- [useOfflineStatus](https://github.com/aromalanil/useCustomHooks/tree/master/docs#-useofflinestatus)

## 📄 Documentation
For documentation, examples and other details refer [Documentation](https://github.com/aromalanil/useCustomHooks/tree/master/docs)


## 🤝🏻 Contributing

### Guidelines 📋
Please read [CONTRIBUTING](https://github.com/aromalanil/useCustomHooks/blob/master/CONTRIBUTING.md) for Code of Conduct, details and the process for submitting pull requests to us.

Basic steps:
1. [Open an issue](https://github.com/aromalanil/useCustomHooks/issues/new/choose) explaining the changes.
2. Work on the issue after you get assigned.
3. Fork this repo.
4. Install the dependencies using `npm install`.
5. Make the changes.
6. Check for linting errors using `npm run lint`.
7. [Open PR](https://github.com/aromalanil/useCustomHooks/compare) when the feature/fix is ready.
8. The collaborators will review your PR and if approved will merge to the master.

</br>

## Contributors ✨

Thanks goes to these wonderful people ([emoji key](https://allcontributors.org/docs/en/emoji-key)):

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tr>
    <td align="center"><a href="http://aromalanil.me"><img src="https://avatars1.githubusercontent.com/u/49222186?v=4" width="100px;" alt=""/><br /><sub><b>Aromal Anil</b></sub></a><br /><a href="https://github.com/aromalanil/useCustomHooks/commits?author=aromalanil" title="Documentation">📖</a> <a href="https://github.com/aromalanil/useCustomHooks/commits?author=aromalanil" title="Code">💻</a> <a href="#maintenance-aromalanil" title="Maintenance">🚧</a></td>
    <td align="center"><a href="https://www.rahulmahesh.me/"><img src="https://avatars3.githubusercontent.com/u/41413029?v=4" width="100px;" alt=""/><br /><sub><b>Rahul Mahesh</b></sub></a><br /><a href="https://github.com/aromalanil/useCustomHooks/commits?author=RahulMahesh62" title="Documentation">📖</a></td>
    <td align="center"><a href="https://github.com/fernandoamz"><img src="https://avatars3.githubusercontent.com/u/7818620?v=4" width="100px;" alt=""/><br /><sub><b>Fernando Amezcua</b></sub></a><br /><a href="https://github.com/aromalanil/useCustomHooks/commits?author=fernandoamz" title="Code">💻</a> <a href="https://github.com/aromalanil/useCustomHooks/commits?author=fernandoamz" title="Documentation">📖</a></td>
    <td align="center"><a href="https://github.com/minimatrix"><img src="https://avatars1.githubusercontent.com/u/23636134?v=4" width="100px;" alt=""/><br /><sub><b>Jonathan Carter</b></sub></a><br /><a href="https://github.com/aromalanil/useCustomHooks/commits?author=minimatrix" title="Code">💻</a> <a href="https://github.com/aromalanil/useCustomHooks/commits?author=minimatrix" title="Documentation">📖</a></td>
    <td align="center"><a href="https://github.com/MuriloucoLouco"><img src="https://avatars1.githubusercontent.com/u/58440129?v=4" width="100px;" alt=""/><br /><sub><b>Murilo Leandro</b></sub></a><br /><a href="https://github.com/aromalanil/useCustomHooks/commits?author=MuriloucoLouco" title="Code">💻</a> <a href="https://github.com/aromalanil/useCustomHooks/commits?author=MuriloucoLouco" title="Documentation">📖</a></td>
  </tr>
</table>

<!-- markdownlint-enable -->
<!-- prettier-ignore-end -->
<!-- ALL-CONTRIBUTORS-LIST:END -->

This project follows the [all-contributors](https://allcontributors.org) specification.
Contributions of any kind are welcome!

</br>

## 📜 License

```
Copyright (c) 2020 Aromal Anil

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
```

## ✍🏻 Creator

[Aromal Anil](https://aromalanil.tech)
